<template lang="pug">
.field.is-marginless( v-if='$slots.default' )
	label.label.mb-2
		slot
.field.is-grouped( v-if='editor' )
	.control.is-expanded
		.buttons
			.button( @click='editor.chain().focus().toggleHeading({ level: 3 }).run()' :class='{ "is-black": editor.isActive("heading", { level: 3 }) }' ) H3

			.button( @click='editor.chain().focus().toggleBulletList().run()' :class='{ "is-black": editor.isActive("bulletList") }' )
				span.icon
					i.fa-solid.fa-list

			.button( @click='editor.chain().focus().toggleBold().run()' :class='{ "is-black": editor.isActive("bold") }' )
				span.has-text-weight-bold B

			.button( @click='editor.chain().focus().toggleItalic().run()' :class='{ "is-black": editor.isActive("italic") }' )
				span.is-italic I
.field
	.control
		editor-content( :editor='editor' )
</template>

<script setup>
import { Editor, EditorContent } from "@tiptap/vue-3"
import StarterKit from "@tiptap/starter-kit"

import { computed, onMounted, ref, watch } from "vue"

const props = defineProps({ modelValue: Object })
const emit = defineEmits(["update:modelValue"])

const editor = ref()

const noHeading = computed(() => !([2, 3, 4, 5]).find(level => editor.value.isActive("heading", { level })))

const heading = e => editor.value.chain().focus().toggleHeading({ level: parseInt(e.target.value) }).run()

const upd = ({ editor }) => {
	const html = editor.getHTML()
	emit("update:modelValue", { data: html == "<p></p>" ? "" : html })
}

watch(() => props.modelValue, (nv, ov) => {
	if (nv?.data?.trim() !== ov?.data?.trim()) {
		const { from, to } = editor.value?.state.selection

		editor.value?.commands.setContent(nv.data, true, { preserveWhitespace: true })

		editor.value?.commands.setTextSelection({ from, to })
	}
})

onMounted(() => {
	editor.value = new Editor({
		extensions: [ StarterKit ],
		content: props.modelValue?.data || "",
		editorProps: {
			attributes: {
				class: "textarea content"
			}
		},
		onUpdate: upd,
		onCreate: upd
	})
})
</script>

<style lang="scss" scoped>
.control {
	&:deep(.textarea) {
		max-height: unset;
		height: auto;
	}
}
</style>